/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.
Handle Program Writer
by omercury

Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>          //  

#define shortkey  0x3C    //80 .  -    
#define longkey   0xFE    //240.  -    
#define PWM_del   0x0A    //15.     
#define PWM_start 0xFA    //125. .   

//eeprom unsigned char PWM_start = 125;
unsigned char   tmpPWM = PWM_start; 
unsigned char   count = 0;      //   
unsigned char   b_count = 0;    //   
bit     KeyEXE;                     //  
bit     KeyNew;                     //  
bit     PWM_on;                     //   
bit     Dir_on;                     //   PWM

#define SBIT(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define CBIT(ADDRESS,BIT)  ((ADDRESS) &= ~(1<<(BIT)))
#define KeyPress    (!PINB.0)       // 
#define led_on      (PORTB.3)

//  (.  )
void    bright_ch(void)
{
    b_count++;				    //  
    if  (b_count>=PWM_del)	    // 
    {                   
        if  (Dir_on)            //     +
        {   
            OCR2++;             // 
            if  (OCR2==0){OCR2=0xFF;}  //  
        }
        else                    //     -
        {
            OCR2--;  			//            
            if (OCR2==0xFF){ OCR2=0;}  //  
        } 
        b_count = 0x00;		//    
    }
}
// 
void    clr_var(void)
{
    count = 0;          //    
    b_count = 0;        //     PWM   
    KeyNew = 0;         //       
    
}
/// 
void    led_on_off(void)
{
    if  (PWM_on)                //   ()
    {    
        tmpPWM = OCR2;  
        OCR2=0xFF;              // 
        PWM_on = 0;             // 
    }
    else                        //   - 
    {     
        OCR2=tmpPWM;//PWM_start;         //
        PWM_on = 1;             //    
    }                                               
}

// 
void    key_scan(void)
{
    if  KeyPress                //  
    {                            //,    
        if (KeyNew)             //   ( "")
        {                                          
            count++;          //  
            if  (count>longkey) //  
            {                                
                bright_ch();    //   
                count--;        // (-   )
                PWM_on = 1;
            }                   //
        } 
        else                    //  ,    
        {   
            KeyNew = 1;         // 
        }                       //
    }   
    else                        //      ,  
    {       //        ,     
        if (KeyNew)             //   (  )
        {                       //,    
            if (count<longkey)  //  ( )
            {//   ,      ,       
                if (count>shortkey) //   (,   )
                {                     
                    led_on_off();   /// 
                }               // -   
            }   
            else    {Dir_on=~Dir_on;}   //   
        }                       
        clr_var();              // 
    }                           //  
    KeyEXE = 0;                 //     
    #asm("sleep")               // 
}

// Time 0 overflow interrupt service routine
//   8 mS
interrupt [TIM2_OVF] void Time2_ovf_isr(void)
{ 
    KeyEXE = 1;          //  
}

void main(void)
{
// Input/Output Ports initialization
PORTB=0x09;
DDRB=0x08;
// Port C initialization
PORTC=0x00;
DDRC=0x00;
// Port D initialization
PORTD=0x00;
DDRD=0x00;
// Time/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
TCCR0=0x00;//0x04;     //off
TCNT0=0x00;

// Time/Counter 2 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz *4 = 31.25kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Inverted PWM
ASSR=0x00;
TCCR2=0x7C;//6C;//6F;
TCNT2=0x00;
OCR2=0xFF;

// Time(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x40;

// Global enable interrupts
#asm("sei")

while (1)
      {
            if  (KeyEXE)
            {  
                key_scan();
            }
      }
}
